/*
 *
 *   --- THIS FILE GENERATED BY S-FUNCTION BUILDER: 2.0 ---
 *
 *   This file is a wrapper S-function produced by the S-Function
 *   Builder which only recognizes certain fields.  Changes made
 *   outside these fields will be lost the next time the block is
 *   used to load, edit, and resave this file. This file will be overwritten
 *   by the S-function Builder block. If you want to edit this file by hand, 
 *   you must change it only in the area defined as:  
 *
 *        %%%-SFUNWIZ_wrapper_XXXXX_Changes_BEGIN 
 *            Your Changes go here
 *        %%%-SFUNWIZ_wrapper_XXXXXX_Changes_END
 *
 *   For better compatibility with the Real-Time Workshop, the
 *   "wrapper" S-function technique is used.  This is discussed
 *   in the Real-Time Workshop User's Manual in the Chapter titled,
 *   "Wrapper S-functions".
 *
 *   Created: Mon May  5 11:01:14 2003
 */


/*
 * Include Files
 *
 */
#include "tmwtypes.h"
/* %%%-SFUNWIZ_wrapper_includes_Changes_BEGIN --- EDIT HERE TO _END */
#include <math.h>


/* %%%-SFUNWIZ_wrapper_includes_Changes_END --- EDIT HERE TO _BEGIN */
#define u_width 1
#define y_width 1
/*
 * Create external references here.  
 *
 */
/* %%%-SFUNWIZ_wrapper_externs_Changes_BEGIN --- EDIT HERE TO _END */
/* extern double func(double a); */


/* %%%-SFUNWIZ_wrapper_externs_Changes_END --- EDIT HERE TO _BEGIN */

/*
 * Output functions
 *
 */
void Decision_Outputs_wrapper(const int8_T *Symbol,
                          const boolean_T *Detect,
                          int8_T *Valid_sym,
                          int8_T *Stb,
                          const real_T *xD)
{
/* %%%-SFUNWIZ_wrapper_Outputs_Changes_BEGIN --- EDIT HERE TO _END */
  Valid_sym[0] = xD[6];
      Stb[0] = xD[7];
  
 

/* %%%-SFUNWIZ_wrapper_Outputs_Changes_END --- EDIT HERE TO _BEGIN */
}

/*
 * Updates function
 *
 */
void Decision_Update_wrapper(const int8_T *Symbol,
                          const boolean_T *Detect,
                          const int8_T *Valid_sym,
                          const int8_T *Stb,
                          real_T *xD)
{
/* %%%-SFUNWIZ_wrapper_Update_Changes_BEGIN --- EDIT HERE TO _END */

/*------------------ DECISION LOGIC ----------------------------

         This decision logic is implemented at a further decimated rate
         of 2 kHz

         Notation used in decision logic
         DT = Detect signal    
         Counter = Count
         Prev_simbol = Previous symbol
         Sig_dur_cnt = Signal timer
         Non_sig_dur_cnt = Timer count 
         New_simbol = New symbol
         VS = Valid symbol

  :
          ( )   10 ,    
       ,       . 
                

  Output:
  Valid_sym[0] = xD[6];
  Stb[0] = xD[7];


*/
int16_T Non_sig_dur_cnt;    // Counts non-signal duration
int16_T Sig_dur_cnt;        // Counts signal duration
int8_T Prev_simbol;         // Detected digit in previous iteration
int8_T New_simbol;
int8_T VS;                  // Previously detected valid digit 
int16_T Counter;            // Counter
int8_T Out_sym;
int8_T Out_stb;
boolean_T DT;
int32_T n;
  
#define  N5ms  2
#define  N10ms 5
#define  N23ms 12

#define n               xD[0]   
#define Non_sig_dur_cnt xD[1] 
#define Sig_dur_cnt     xD[2]  
#define Prev_simbol     xD[3]  
#define VS              xD[4]
#define Counter         xD[5]
#define Out_sym         xD[6]
#define Out_stb         xD[7]
#define DT          Detect[0]
#define New_simbol  Symbol[0];
 
  
  Out_stb=0;
  if ((n % 2) == 0)                                  //      
  {    
    if((New_simbol >= 0) & (DT != 0))              
    {
      //      
      Non_sig_dur_cnt = N10ms;  //                          
      if(Prev_simbol == New_simbol)               
      {
        //      5 
        if(Sig_dur_cnt > N5ms)                  
        {
          if(VS == New_simbol)                
             Counter = Counter + Sig_dur_cnt;
          else                                
             Counter = Sig_dur_cnt;  //       ,   
                                     //       
          //       5 ,    
          VS = New_simbol;                    
          Sig_dur_cnt = 0;                    
        }
        else
        {
          Sig_dur_cnt = Sig_dur_cnt + 1;      
        }  
      }  
      else                                        
      {
        //              
        if((Sig_dur_cnt > 0) & (VS == Prev_simbol))               
           Counter = Counter + Sig_dur_cnt; //     ,      
                                            //        
        Sig_dur_cnt = 0;                        
      }  
      Prev_simbol = New_simbol;                   
    }  
    else                                            
    {
      //         
      if((Sig_dur_cnt > 0) & (VS == Prev_simbol))
          //        
        Counter = Counter + Sig_dur_cnt;        
      Sig_dur_cnt = 0;          
      if(Non_sig_dur_cnt == 0)                    
      {
        //   10     ( )
        //         
        if(Counter > N23ms)           
        {
          //         23             
          Out_sym = VS;               
          Out_stb=1;      
        }                                    
        Counter = 0;                            
        VS = -1;                                
        Prev_simbol = -1;                       
      }
      else
      {        
        if(DT == 0)  //    ,                                
           Non_sig_dur_cnt = Non_sig_dur_cnt - 1;                        
      }
    }
  }        
  
  n++;

/* %%%-SFUNWIZ_wrapper_Update_Changes_END --- EDIT HERE TO _BEGIN */
}

/*
 *  Derivatives function
 *
 */
void Decision_Derivatives_wrapper(const int8_T *Symbol,
                          const boolean_T *Detect,
                          const int8_T *Valid_sym,
                          const int8_T *Stb,
                          real_T *dx )
{
/* %%%-SFUNWIZ_wrapper_Derivatives_Changes_BEGIN --- EDIT HERE TO _END */
 
 

/* %%%-SFUNWIZ_wrapper_Derivatives_Changes_END --- EDIT HERE TO _BEGIN */
}





